"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_status_codes_1 = require("http-status-codes");
const schema_validator_1 = require("./schema-validator");
const defaultPropertiesToValidate = ['params', 'body', 'query'];
exports.expressYupMiddleware = ({ schemaValidator, expectedStatusCode, propertiesToValidate = defaultPropertiesToValidate, }) => (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    const errors = yield schema_validator_1.validatePayload({
        schemaValidator,
        payload: req,
        propertiesToValidate,
    });
    if (!errors) {
        return next();
    }
    return res.status(expectedStatusCode || http_status_codes_1.BAD_REQUEST).send({ errors });
});
//# sourceMappingURL=express-yup-middleware.js.map